#include "utils.h"
#include "error.h"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/param.h>
#include <unistd.h>

void *safe_malloc(int size)
{
  void *mymem;
  fflush(stdout);
  if (size < 0)    
    fatal("Tried to malloc negative amount of memmory!!!");
  mymem = malloc(size);
  if (mymem == NULL)    
    fatal("Malloc Failed! Probably out of space.");
  fflush(stdout);
  return mymem;
}

/* Trivial function that returns nonzero if all characters in str of length strlength are
   printable (as defined by isprint()) */
int stringisprintable(const char *str, int strlength) {
  int i;
  for(i=0; i < strlength; i++)
    if (!isprint((unsigned char) str[i]))
      return 0;

  return 1;
}

/* Convert non-printable characters to replchar in the string */
void replacenonprintable(char *str, int strlength, char replchar) {
  int i;
  for(i=0; i < strlength; i++)
    if (!isprint( (unsigned char) str[i]))
      str[i] = replchar;

  return;
}
